/*----------------------------------------------------------------
	author: massimo.sala.71@gmail.com
	license: MIT
	pls report bugs/improvements to me
*/

#include "config.h"

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#include "chk_string_mask.h"
#include "protocol.h"
#include "exceptions/IOException.h"
#include "exceptions/MemoryException.h"
#include "exceptions/ProtocolException.h"


/**
 *  Vnc test. Default port: 5900/tcp
 *
 *  @file
 */
void check_vnc(Socket_T socket)
{
	#define REPLY_LEN	12			// RFB 003.00?\n
	char reply[REPLY_LEN + 1];
	#define VNC_Mac_OS_X			"RFB 003.889\n"
	int br;

	ASSERT(socket);

	br = Socket_read(socket, reply, REPLY_LEN);
	if (br <= 0)
		THROW(IOException, "VNC: did not receive answer from server -- %s", STRERROR);
	if (br != REPLY_LEN)
		THROW(ProtocolException, "VNC: Received %d bytes from server, expected %d bytes", br, REPLY_LEN);

	reply[br] = 0;
	if (chk_string_mask(reply, REPLY_LEN, "RFB 003.009\n"))
		return;
	if (strcmp(reply, VNC_Mac_OS_X) == 0)
		return;
	THROW(ProtocolException, "VNC: unknown server response -- %s", STRERROR);
}
